import groovy.lang.GroovyObject;
import org.codehaus.groovy.runtime.GStringImpl;
import java.util.Arrays;

public class CallingFromJava {
  public static void main(String[] args) {
    // Multimethods won't work from Java
    SampleGroovyClass inst = new SampleGroovyClass2();
    inst.foo(1);
    //The above when run in Groovy will call foo in derived class

    //Using plus
    inst.plus(inst); // This can be called as + in Groovy

    //Creating GString
    inst.printMessage(new GStringImpl(
      new Object[] { new java.util.Date(), "John"},
      new String[] { "Today is", " how are you, "}));

    //Invoke Dynamic Method before adding it
    callDynamicMethod(new SampleGroovyClass());

    // add the dynamic method
    SampleGroovyClass.addMethod();

    //Invoke Dynamic Method ater adding it
    callDynamicMethod(new SampleGroovyClass());

    //Passing collection
    GroovyClass groovyInst = new GroovyClass();
    groovyInst.people(Arrays.asList("Jack", "Jill"));

    //Calling method with closure
    groovyInst.receiveBlock(new Object() {
      public String call() {
        System.out.println("you called?");
        return "block1";
      }
    });

    groovyInst.receiveBlockWParam(new Object() {
      public String call(int value) {
        System.out.println("you called with " + value);
        return "block1";
      }
    });
  }


  private static void callDynamicMethod(GroovyObject inst) {
     try {
       inst.invokeMethod("method1", null);
     } catch(Exception ex) {
       System.out.println(ex.getMessage());
     }
  }
}
